/**
  * AbulEduLabelV1
  *
  * @warning aucun traitement d'erreur n'est pour l'instant implémenté
  * @see https://redmine.ryxeo.com/projects/leterrier-aller
  * @author 2011 Jean-Louis Frucot <frucot.jeanlouis@free.fr>
  * @see The GNU Public License (GPL)
  *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include "abuledulabelframev1.h"
#include "abuledulabelwidgetv1.h"
#include <QDebug>

AbulEduLabelFrameV1::AbulEduLabelFrameV1(int orientation,QWidget *parent) :
    QFrame(parent)
{
    m_orientation = orientation;
    m_abuleduLabelSelected = -1;
    m_PosListeLabels = QPoint(10,10);
    m_marge = 10;
    m_largeurEtiquettes = 0;
    m_listeAbulEduLabels.clear();
    setFixedSize(200, 50);
    connect(parent, SIGNAL(moveSelectedLabelUp()), this, SLOT(moveSelectedAbulEduLabelUp()));
    connect(parent, SIGNAL(moveSelectedLabelDown()), this, SLOT(moveSelectedAbulEduLabelDown()));
    connect(parent, SIGNAL(moveSelectedLabelLeft()), this, SLOT(moveSelectedAbulEduLabelLeft()));
    connect(parent, SIGNAL(moveSelectedLabelRight()), this, SLOT(moveSelectedAbulEduLabelRight()));
    connect(this, SIGNAL(btnDroiteSetVisible(bool)), parent, SLOT(btnDroiteSetVisible(bool)));
    connect(this, SIGNAL(btnGaucheSetVisible(bool)), parent, SLOT(btnGaucheSetVisible(bool)));
    connect(this, SIGNAL(btnHautSetVisible(bool)), parent, SLOT(btnHautSetVisible(bool)));
    connect(this, SIGNAL(btnBasSetVisible(bool)), parent, SLOT(btnBasSetVisible(bool)));
    connect(this, SIGNAL(btnDroiteSetEnabled(bool)), parent, SLOT(btnDroiteSetEnabled(bool)));
    connect(this, SIGNAL(btnGaucheSetEnabled(bool)), parent, SLOT(btnGaucheSetEnabled(bool)));
    connect(this, SIGNAL(btnHautSetEnabled(bool)), parent, SLOT(btnHautSetEnabled(bool)));
    connect(this, SIGNAL(btnBasSetEnabled(bool)), parent, SLOT(btnBasSetEnabled(bool)));
    connect(this, SIGNAL(AbulEduLabel_moved(AbuleduLabelV1 *)), this, SLOT(on_AbulEduLabel_moved(AbuleduLabelV1 *)));
}

void AbulEduLabelFrameV1::abelabelCreeAbulEduLabels(QStringList listeTextes)
{
    qDebug()<<"AbulEduLabelFrame::abelabelCreeAbulEduLabels(Start)";
    // Au cas ou il y aurait des abuleduLabels qui trainent, on les efface
    QMap<int, AbuleduLabelV1 *> aEffacer = abelabelListeAbuleduLabelsByNumPlace();
    for(int i=0; i<aEffacer.size();i++)
    {
        delete aEffacer[i];
    }
    m_listeAbulEduLabels = abelabelListeAbuleduLabelsByNumPlace();
    //Création des abuleduLabel : un par mot
    for(int i=0;i<listeTextes.size();i++)
    {
        AbuleduLabelV1* etiq = new AbuleduLabelV1(listeTextes[i],i,i,this);
        etiq->setObjectName("Etiquette "+QString::number(i));
        etiq->abelabelSetMarge(m_marge);
        etiq->setAcceptDrops(true);
        m_listeAbulEduLabels.insert(i, etiq);
    }
    if(m_orientation == Qt::Vertical)
    {
        emit btnDroiteSetVisible(false);
        emit btnGaucheSetVisible(false);
    }
    else
    {
        emit btnHautSetVisible(false);
        emit btnBasSetVisible(false);
    }
    abelabelDeselectionneLabels();
    abelabelResizeLabels();
    abelabelPlaceAbulEduLabelsByNumPlace();
    abelabelMontreEtiquettes(true);
    qDebug()<<"AbulEduLabelFrame::abelabelCreeAbulEduLabels(End)";
}

QMap<int, AbuleduLabelV1 *>AbulEduLabelFrameV1::abelabelListeAbuleduLabelsByNumPlace()
{
    qDebug()<<"AbulEduLabelFrame::abelabelListeAbuleduLabelsByNumPlace(start)";
    QList<AbuleduLabelV1 *> listEtiquettes =  findChildren<AbuleduLabelV1 *>();
    QMap<int, AbuleduLabelV1 *> listAbuleduLabels;

    foreach(AbuleduLabelV1 *etiq, listEtiquettes)
    {
        listAbuleduLabels.insert(etiq->abelabelNumPlace(), etiq);
    }
    qDebug()<<"AbulEduLabelFrame::abelabelListeAbuleduLabelsByNumPlace(End)";
    return listAbuleduLabels;
}

QMap<int, AbuleduLabelV1 *>AbulEduLabelFrameV1::abelabelListeAbuleduLabelsByNumOrdre()
{
    qDebug()<<"AbulEduLabelFrame::abelabelListeAbuleduLabelsByNumOrdre(start)";
    QList<AbuleduLabelV1 *> listEtiquettes =  findChildren<AbuleduLabelV1 *>();
    QMap<int, AbuleduLabelV1 *> listAbuleduLabels;

    foreach(AbuleduLabelV1 *etiq, listEtiquettes)
    {
        listAbuleduLabels.insert(etiq->abelabelNumOrdre(), etiq);
    }
    qDebug()<<"AbulEduLabelFrame::abelabelListeAbuleduLabelsByNumOrdre(End)";
    return listAbuleduLabels;
}

void AbulEduLabelFrameV1::abelabelPlaceAbulEduLabelsByNumPlace()
{
    qDebug()<<"AbulEduLabelFrame::abelabelPlaceAbulEduLabelsByNumPlace(Start)";
    QMap<int, AbuleduLabelV1 *> listeByNumPlace;
    listeByNumPlace.clear();
    for(int i=0; i<m_listeAbulEduLabels.size();i++)
    {
        listeByNumPlace.insert(m_listeAbulEduLabels.value(i)->abelabelNumPlace(), m_listeAbulEduLabels.value(i));
    }

    int x = m_PosListeLabels.x();
    int y = m_PosListeLabels.y();


    QMapIterator<int, AbuleduLabelV1 *> i(listeByNumPlace);
    while (i.hasNext())
    {
        i.next();
        i.value()->move(x, y);
        i.value()->abelabelSetLastPos(x, y);
        if(m_orientation == Qt::Vertical)
        {
            y = y + m_marge + i.value()->height();
        }
        else
        {
            x = x + m_marge + i.value()->width();
        }
    }
    qDebug()<<"AbulEduLabelFrame::abelabelPlaceAbulEduLabelsByNumPlace(Stop)";
}

void AbulEduLabelFrameV1::abelabelPlaceAbulEduLabelsByNumOrdre()
{
    qDebug()<<"AbulEduLabelFrame::abelabelPlaceAbulEduLabelsByNumOrdre(Start)";
    QMap<int, AbuleduLabelV1 *> listeByNumOrdre = abelabelListeAbuleduLabelsByNumOrdre();



    int x = m_PosListeLabels.x();
    int y = m_PosListeLabels.y();


    QMapIterator<int, AbuleduLabelV1 *> i(listeByNumOrdre);
    while (i.hasNext())
    {
        i.next();
        i.value()->move(x, y);
        i.value()->abelabelSetLastPos(x, y);
        if(m_orientation == Qt::Vertical)
        {
            y = y + m_marge + i.value()->height();
        }
        else
        {
            x = x + m_marge + i.value()->width();
        }
    }
    qDebug()<<"AbulEduLabelFrame::abelabelPlaceAbulEduLabelsByNumOrdre(Stop)";
}
void AbulEduLabelFrameV1::abelabelMontreEtiquettes(bool onOff)
{
    qDebug()<<"AbulEduLabelFrame::abelabelMontreEtiquettes(Start)";
    for(int i = 0; i < m_listeAbulEduLabels.size(); i++)
    {
        if(onOff)
        {
            m_listeAbulEduLabels.value(i)->show();
        }
        else
        {
            m_listeAbulEduLabels.value(i)->hide();
        }
    }
    qDebug()<<"AbulEduLabelFrame::abelabelMontreEtiquettes(Stop)";
}


void AbulEduLabelFrameV1::abelabelDeplaceEtiquette(int deplacement)
{
    qDebug()<<"AbulEduLabelFrame::abelabelDeplaceEtiquette(Start)";
    if(deplacement == -1 || deplacement == +1)
    {
        if(abelabelSwapAbuleduLabel(m_abuleduLabelSelected,m_abuleduLabelSelected-deplacement))
        {
            m_abuleduLabelSelected=m_abuleduLabelSelected-deplacement;
            m_listeAbulEduLabels=abelabelListeAbuleduLabelsByNumPlace();

            emit AbulEduLabel_moved(m_listeAbulEduLabels.value(m_abuleduLabelSelected));
            if(m_abuleduLabelSelected == 0)
            {
                emit btnHautSetEnabled(false);
                emit btnGaucheSetEnabled(false);
            }
            else
            {
                emit btnHautSetEnabled(true);
                emit btnGaucheSetEnabled(true);
            }
            if(m_abuleduLabelSelected == m_listeAbulEduLabels.size()-1)
            {
                emit btnBasSetEnabled(false);
                emit btnDroiteSetEnabled(false);
            }
            else
            {
                emit btnBasSetEnabled(true);
                emit btnDroiteSetEnabled(true);
            }
        }
    }
    qDebug()<<"AbulEduLabelFrame::abelabelDeplaceEtiquette(Stop)";
    traceEtiquettes();
}

bool AbulEduLabelFrameV1::abelabelSwapAbuleduLabel(int rangEtiq1, int rangEtiq2)
{
    qDebug()<<"AbulEduLabelFrame::abelabelSwapAbuleduLabel(Start)";
    QMap<int, AbuleduLabelV1 *> listeItems = this->abelabelListeAbuleduLabelsByNumPlace();
    if(rangEtiq1 >= 0
            && rangEtiq2 >= 0
            && rangEtiq1 < listeItems.size()
            && rangEtiq2 < listeItems.size())
    {
        listeItems.value(rangEtiq1)->abelabelSetNumPlace(rangEtiq2);
        listeItems.value(rangEtiq2)->abelabelSetNumPlace(rangEtiq1);
        abelabelPlaceAbulEduLabelsByNumPlace();

//        traceEtiquettes();
        qDebug()<<"AbulEduLabelFrame::abelabelSwapAbuleduLabel(Stop)";
                return true;

    }
    else
    {
        qDebug()<<"AbulEduLabelFrame::abelabelSwapAbuleduLabel(Stop)";
        return false; // les étiquettes n'ont pas été permutées
    }

}

void AbulEduLabelFrameV1::abelabelDeselectionneLabels()
{
    // Un clic en dehors d'une étiquette déselectionne les étiquettes
    QList<AbuleduLabelV1 *> listeEtiquettes = this->findChildren<AbuleduLabelV1 *>();
    foreach(AbuleduLabelV1* etiq, listeEtiquettes)
    {
        etiq->setStyleSheet("");
    }
    m_abuleduLabelSelected=-1; // -1 pas d'étiquette sélectionnée
    emit btnHautSetEnabled(false);
    emit btnBasSetEnabled(false);
    emit btnGaucheSetEnabled(false);
    emit btnDroiteSetEnabled(false);
}

void AbulEduLabelFrameV1::abelabelMelangeAbulEduLabels()
{
    QMap<int, AbuleduLabelV1 *> tmpListe = abelabelListeAbuleduLabelsByNumOrdre();
    QList<int> tmpPlace;
    for(int i = 0; i<tmpListe.size(); i++)
        tmpPlace<<i;

    int hasard = 0;
    QMapIterator<int, AbuleduLabelV1 *> i(tmpListe);
    while (i.hasNext())
    {
        i.next();
       hasard = qrand()%tmpPlace.size();
       hasard = tmpPlace.takeAt(hasard);
       i.value()->abelabelSetNumPlace(hasard);
    }
    abelabelPlaceAbulEduLabelsByNumPlace();
    m_listeAbulEduLabels = abelabelListeAbuleduLabelsByNumPlace();
traceEtiquettes();
}

void AbulEduLabelFrameV1::abelabelSetMarge(int marge)
{
    m_marge=marge;
}

void AbulEduLabelFrameV1::abelabelSetPosListeLabels(QPoint position)
{
    m_PosListeLabels = position;
}

void AbulEduLabelFrameV1::abelabelSetPosListeLabels(int x, int y)
{
    m_PosListeLabels = QPoint(x, y);
}

void AbulEduLabelFrameV1::abelabelSetLargeurEtiquettes(int largeur)
{
    m_largeurEtiquettes = largeur;
}
void AbulEduLabelFrameV1::abelabelSetOrientation(int orientation)
{
    m_orientation = orientation;
    abelabelPlaceAbulEduLabelsByNumPlace();
}

int AbulEduLabelFrameV1::abelabelOrientation()
{
    return m_orientation;
}

QSize AbulEduLabelFrameV1::abelabelResizeFrame()
{
    qDebug()<<"AbulEduLabelFrame::abelabelResizeFrame(Start)";
    int haut = m_PosListeLabels.y();
    int larg = 0;
    if(m_orientation==Qt::Vertical)
    {
        for(int i =0; i < m_listeAbulEduLabels.size(); i++)
        {
            haut = haut + m_listeAbulEduLabels.value(i)->height() + m_marge;
            larg = qMax(larg, m_listeAbulEduLabels.value(i)->width());
        }
        larg = larg + 2*m_PosListeLabels.x();
    }
    else
    {
        // Cas de la liste horizontale (haut ne change pas)
        int ymax = 0;
        for(int i =0; i < m_listeAbulEduLabels.size(); i++)
        {
            ymax= qMax(ymax,m_listeAbulEduLabels.value(i)->height());
            larg = larg + m_listeAbulEduLabels.value(i)->width() +m_marge;
        }
        haut = haut + ymax + m_PosListeLabels.y();
        larg = larg + m_marge;
    }
    this->setFixedSize(larg, haut);
    qDebug()<<"AbulEduLabelFrame::abelabelResizeFrame(End)";
    return QSize(larg, haut);
}

void AbulEduLabelFrameV1::abelabelResizeLabels()
{
    qDebug()<<"AbulEduLabelFrame::abeLabel_resizeLabels(Start)";
    if(m_largeurEtiquettes != 0)
    {
        for(int i = 0; i < m_listeAbulEduLabels.size(); i++)
        {
            m_listeAbulEduLabels.value(i)->setFixedWidth(m_largeurEtiquettes);
            m_listeAbulEduLabels.value(i)->setFixedHeight(m_listeAbulEduLabels.value(i)->abelabelMarge()*2+fontMetrics().height() *  (1+fontMetrics().width(m_listeAbulEduLabels.value(i)->text()) / m_listeAbulEduLabels.value(i)->width()));
        }
    }
    qDebug()<<"AbulEduLabelFrame::abeLabel_resizeLabels(End)";
}



void AbulEduLabelFrameV1::on_abuleduLabelSelected(int rang)
{
    qDebug()<<"AbulEduLabelFrame::on_abuleduLabelSelected(start)";

    m_abuleduLabelSelected = rang;
    if(m_abuleduLabelSelected == 0)
    {
        emit btnHautSetEnabled(false);
        emit btnGaucheSetEnabled(false);
    }
    else
    {
        emit btnHautSetEnabled(true);
        emit btnGaucheSetEnabled(true);
    }
    if(m_abuleduLabelSelected == m_listeAbulEduLabels.size()-1)
    {
        emit btnBasSetEnabled(false);
        emit btnDroiteSetEnabled(false);
    }
    else
    {
        emit btnBasSetEnabled(true);
        emit btnDroiteSetEnabled(true);
    }
    qDebug()<<"AbulEduLabelFrame::on_abuleduLabelSelected(start)";
}

void AbulEduLabelFrameV1::moveSelectedAbulEduLabelUp()
{
    qDebug()<<"Slot AbulEduLabelFrame::moveSelectedAbulEduLabelUp(start)";
    abelabelDeplaceEtiquette(+1);
    qDebug()<<"Slot AbulEduLabelFrame::moveSelectedAbulEduLabelUp(stop)";
}
void AbulEduLabelFrameV1::moveSelectedAbulEduLabelDown()
{
    qDebug()<<"Slot AbulEduLabelFrame::moveSelectedAbulEduLabelDown(start)";
    abelabelDeplaceEtiquette(-1);
    qDebug()<<"Slot AbulEduLabelFrame::moveSelectedAbulEduLabelDown(stop)";
}
void AbulEduLabelFrameV1::moveSelectedAbulEduLabelLeft()
{
    qDebug()<<"Slot AbulEduLabelFrame::moveSelectedAbulEduLabelLeft(Start)";
    abelabelDeplaceEtiquette(+1);
    qDebug()<<"Slot AbulEduLabelFrame::moveSelectedAbulEduLabelLeft(stop)";
}
void AbulEduLabelFrameV1::moveSelectedAbulEduLabelRight()
{
    qDebug()<<"Slot AbulEduLabelFrame::moveSelectedAbulEduLabelRight(Start)";
    abelabelDeplaceEtiquette(-1);
    qDebug()<<"Slot AbulEduLabelFrame::moveSelectedAbulEduLabelRight(stop)";
}

void AbulEduLabelFrameV1::on_AbulEduLabel_moved(AbuleduLabelV1 *etiq)
{
    if(m_orientation == Qt::Vertical)
    {
        static_cast<QScrollArea *>(parentWidget()->parentWidget())->ensureWidgetVisible(etiq,80,80);
    }
    else
    {
        static_cast<QScrollArea *>(parentWidget()->parentWidget())->ensureWidgetVisible(etiq,80,80);
    }
}


void AbulEduLabelFrameV1::mousePressEvent(QMouseEvent *event)
{
    abelabelDeselectionneLabels();
    event->accept();
}


void AbulEduLabelFrameV1::childEvent(QChildEvent *event)
{
    AbuleduLabelV1 *etiq = static_cast<AbuleduLabelV1 *>(event->child());
    if(etiq)
    {
        switch(event->type())
        {
        case QChildEvent::ChildAdded:
            break;
        case QChildEvent::ChildPolished:
            abelabelResizeFrame();
            break;
        default:
            break;
        }
    }
}
void AbulEduLabelFrameV1::resizeEvent(QResizeEvent *event)
{


}

void AbulEduLabelFrameV1::traceEtiquettes()
{
    qDebug()<<"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<m_listeAbulEduLabels<<<<<<<<<<<<<<<<<<<<<<<<";
    for(int i=0;i<m_listeAbulEduLabels.size();i++)
    {
        qDebug()<<m_listeAbulEduLabels.value(i)->objectName()
              <<"numOrdre"<<m_listeAbulEduLabels.value(i)->abelabelNumOrdre()
             <<"numPlace"<<m_listeAbulEduLabels.value(i)->abelabelNumPlace()
            <<"lastPos"<<m_listeAbulEduLabels.value(i)->abelabelLastPos();
    }
    qDebug()<<"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<liste par ordre<<<<<<<<<<<<<<<<<<<<<<<<";
    QMap<int, AbuleduLabelV1 *> tmpListe= abelabelListeAbuleduLabelsByNumOrdre();
    for(int i =0; i<m_listeAbulEduLabels.size();i++)
    {
        qDebug()<<tmpListe.value(i);
    }
    qDebug()<<"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<liste par place<<<<<<<<<<<<<<<<<<<<<<<<<";
    tmpListe= abelabelListeAbuleduLabelsByNumPlace();
    for(int i =0; i<m_listeAbulEduLabels.size();i++)
    {
        qDebug()<<tmpListe.value(i);
    }
}
